using HarmonyLib;
using UnityEngine;
using System.Collections.Generic;

public class BetterBetterPause : Mod
{
    private static BetterBetterPause instance;
    Harmony harmony;

    private bool wasPaused = false;
    static bool godmodeWhilePaused;
    public static bool IsPlayerPaused;
    private bool needsToResetInvurnerability = false;
    public static bool GodmodeWhilePaused => ExtraSettingsAPI_Loaded ? godmodeWhilePaused : true;
    private float stat_thirst, stat_thirst_bonus, stat_hunger, stat_hunger_bonus, stat_oxygen = 0;
    public static Network_Player player = RAPI.GetLocalPlayer();

    public void Start()
    {
        instance = this;

        harmony = new Harmony("net.IAteMinecraft.BetterBetterPause");
        harmony.PatchAll();

        Debug.Log("Mod Better, Better Pause has been loaded!");
    }

    public void OnModUnload()
    {
        harmony.UnpatchAll(harmony.Id);

        Debug.Log("Mod Better, Better Pause has been unloaded!");
    }

    static bool ExtraSettingsAPI_Loaded = false;

    public void ExtraSettingsAPI_Load() => ExtraSettingsAPI_SettingsClose();
    public void ExtraSettingsAPI_SettingsClose()
    {
        godmodeWhilePaused = ExtraSettingsAPI_GetCheckboxState("godmodeWhilePaused");
    }

    public bool ExtraSettingsAPI_GetCheckboxState(string SettingName) => false;


public void Update()
    {
        bool paused = CanvasHelper.ActiveMenu.Equals(MenuType.PauseMenu);
        
        if (paused)
        {   
            IsPlayerPaused = true;
            if (!wasPaused)
            {
                stat_thirst = RAPI.GetLocalPlayer().Stats.stat_thirst.Normal.Value;
                stat_hunger = RAPI.GetLocalPlayer().Stats.stat_hunger.Normal.Value;
                stat_oxygen = RAPI.GetLocalPlayer().Stats.stat_oxygen.Value;
                stat_thirst_bonus = RAPI.GetLocalPlayer().Stats.stat_thirst.Bonus.Value;
                stat_hunger_bonus = RAPI.GetLocalPlayer().Stats.stat_hunger.Bonus.Value;
                needsToResetInvurnerability = GodmodeWhilePaused;
                RAPI.GetLocalPlayer().Stats.IsInvurnerable = GodmodeWhilePaused;
            }
            else
            {
                stat_thirst = Mathf.Max(stat_thirst, RAPI.GetLocalPlayer().Stats.stat_thirst.Normal.Value);
                stat_hunger = Mathf.Max(stat_hunger, RAPI.GetLocalPlayer().Stats.stat_hunger.Normal.Value);
                stat_oxygen = Mathf.Max(stat_oxygen, RAPI.GetLocalPlayer().Stats.stat_oxygen.Value);
                stat_thirst_bonus = Mathf.Max(stat_thirst_bonus, RAPI.GetLocalPlayer().Stats.stat_thirst.Bonus.Value);
                stat_hunger_bonus = Mathf.Max(stat_hunger_bonus, RAPI.GetLocalPlayer().Stats.stat_hunger.Bonus.Value);
            }
            RAPI.GetLocalPlayer().Stats.stat_thirst.Normal.Value = stat_thirst;
            RAPI.GetLocalPlayer().Stats.stat_hunger.Normal.Value = stat_hunger;
            RAPI.GetLocalPlayer().Stats.stat_oxygen.Value = stat_oxygen;
            RAPI.GetLocalPlayer().Stats.stat_thirst.Bonus.Value = stat_thirst_bonus;
            RAPI.GetLocalPlayer().Stats.stat_hunger.Bonus.Value = stat_hunger_bonus;
            
            
        }
        wasPaused = paused;
        if (needsToResetInvurnerability && !paused)
        {
            needsToResetInvurnerability = false;
            RAPI.GetLocalPlayer().Stats.IsInvurnerable = false;
        }
        if (!paused)
        {
            IsPlayerPaused = false;
        }
    }   
}

[HarmonyPatch(typeof(BuffDisplayObject), "Update")]
public class Patch_BuffDisplayObject
{
    [HarmonyPrefix]
    static bool Postfix()
    {
        if (CanvasHelper.ActiveMenu.Equals(MenuType.PauseMenu))
        {
            return false;
        }
        return true;
    }
}

[HarmonyPatch(typeof(AI_StateMachine), "UpdateStateMachine")]
static class Patch_ValidTarget
{
    static void Prefix(AI_StateMachine __instance, ref List<Player> __state)
    {
        __state = new List<Player>();
        foreach (Network_Player player in ComponentManager<Raft_Network>.Value.remoteUsers.Values)
            if (!player.PlayerScript.IsDead && BetterBetterPause.IsPlayerPaused)
                {
                    player.PlayerScript.IsDead = true;
                    __state.Add(player.PlayerScript);
                    break;
                }
    }
    static void Finalizer(List<Player> __state)
    {
        foreach (Player player in __state)
            player.IsDead = false;
    }

    [HarmonyPatch(typeof(AI_State_Attack_Block_Shark), "FindBlockToAttack")]
    public static class AIStateAttackBlockShark_FindBlockToAttack_Patch
    {
        private static void Postfix(ref Block __result)
        {
            if ((ComponentManager<Raft_Network>.Value.PlayerCount == 1) && BetterBetterPause.IsPlayerPaused && RAPI.IsCurrentSceneGame())
            {
                __result = null;
            }
        }
    }
}